Zwischencommit fuer LFS.
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0" # Version number
28 SLOGAN="www.ipfire.eu" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which version should be compiled? (full|light|voice)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2202000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2202000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2.1GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j8"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 file
284 lfsmake2 findutils
285 lfsmake2 flex
286 lfsmake2 grub
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 make
297 lfsmake2 man
298 lfsmake2 mktemp
299 lfsmake2 modutils
300 lfsmake2 patch
301 lfsmake2 psmisc
302 lfsmake2 shadow
303 lfsmake2 sysklogd
304 lfsmake2 sysvinit
305 lfsmake2 tar
306 lfsmake2 texinfo
307 lfsmake2 udev
308 lfsmake2 util-linux
309 lfsmake2 vim
310 }
311
312 buildipfire() {
313 LOGFILE="$BASEDIR/log/_build.ipfire.log"
314 export LOGFILE
315 ipfiremake inetutils
316 ipfiremake net-tools
317 ipfiremake ed
318 ipfiremake configroot
319 ipfiremake dhcp
320 ipfiremake dhcpcd
321 ipfiremake libusb
322 ipfiremake libpcap
323 # Temporary disabled.
324 # ipfiremake linux-atm
325 ipfiremake ppp
326 ipfiremake rp-pppoe
327 ipfiremake unzip
328 ipfiremake linux PASS=I
329 ipfiremake linux PASS=S
330 # ipfiremake 3cp4218 PASS=SMP
331 # ipfiremake amedyn PASS=SMP
332 # ipfiremake cxacru PASS=SMP
333 # ipfiremake eagle PASS=SMP
334 # ipfiremake cnx_pci PASS=SMP
335 # ipfiremake fcdsl PASS=SMP
336 # ipfiremake fcdsl2 PASS=SMP
337 # ipfiremake fcdslsl PASS=SMP
338 # ipfiremake fcdslusb PASS=SMP
339 # ipfiremake fcdslslusb PASS=SMP
340 # ipfiremake fcpci PASS=SMP
341 # ipfiremake fcclassic PASS=SMP
342 # ipfiremake pulsar PASS=SMP
343 # ipfiremake unicorn PASS=SMP
344 # ipfiremake promise-sata-300-tx PASS=SMP
345 ipfiremake linux
346 # ipfiremake 3cp4218
347 # ipfiremake amedyn
348 # ipfiremake cxacru
349 # ipfiremake eciadsl
350 # ipfiremake eagle
351 # ipfiremake speedtouch
352 # ipfiremake cnx_pci
353 # ipfiremake fcdsl
354 # ipfiremake fcdsl2
355 # ipfiremake fcdslsl
356 # ipfiremake fcdslusb
357 # ipfiremake fcdslslusb
358 # ipfiremake fcpci
359 # ipfiremake fcclassic
360 # ipfiremake pulsar
361 # ipfiremake unicorn
362 # ipfiremake promise-sata-300-tx
363 # ipfiremake pcmciautils
364 ipfiremake expat
365 ipfiremake gdbm
366 ipfiremake gmp
367 ipfiremake pam
368 ipfiremake openssl
369 ipfiremake python
370 ipfiremake libnet
371 ipfiremake libjpeg
372 ipfiremake libpng
373 ipfiremake libtiff
374 ipfiremake lcms
375 ipfiremake libmng
376 ipfiremake freetype
377 ipfiremake gd
378 ipfiremake popt
379 ipfiremake pcre
380 ipfiremake slang
381 ipfiremake newt
382 # ipfiremake libcap
383 ipfiremake pciutils
384 ipfiremake libxml2
385 ipfiremake BerkeleyDB
386 ipfiremake mysql
387 ipfiremake cyrus-sasl
388 ipfiremake openldap
389 # ipfiremake cyrus-sasl PASS=L # Doesn't work yet. Thereby there's the question: Do we really need this?
390 ipfiremake apache2
391 ipfiremake php
392 ipfiremake subversion
393 ipfiremake apache2 PASS=C
394 ipfiremake arping
395 ipfiremake beep
396 ipfiremake bind
397 ipfiremake capi4k-utils
398 ipfiremake cdrtools
399 ipfiremake dnsmasq
400 ipfiremake dosfstools
401 ipfiremake ethtool
402 ipfiremake ez-ipupdate
403 ipfiremake fcron
404 ipfiremake GD
405 ipfiremake gnupg
406 ipfiremake hdparm
407 ipfiremake ibod
408 ipfiremake initscripts
409 ipfiremake iptables
410 ipfiremake ipac-ng
411 ipfiremake ipaddr
412 ipfiremake iptstate
413 # ipfiremake iputils
414 exit 1
415 ipfiremake l7-protocols
416 ipfiremake isapnptools
417 ipfiremake isdn4k-utils
418 ipfiremake kudzu
419 ipfiremake logrotate
420 ipfiremake logwatch
421 ipfiremake mingetty
422 ipfiremake misc-progs
423 ipfiremake mtools
424 ipfiremake nano
425 ipfiremake nash
426 ipfiremake nasm
427 ipfiremake URI
428 ipfiremake HTML-Tagset
429 ipfiremake HTML-Parser
430 ipfiremake Compress-Zlib
431 ipfiremake Digest
432 ipfiremake Digest-SHA1
433 ipfiremake Digest-HMAC
434 ipfiremake libwww-perl
435 ipfiremake Net-DNS
436 ipfiremake Net-IPv4Addr
437 ipfiremake Net_SSLeay
438 ipfiremake IO-Stringy
439 ipfiremake Unix-Syslog
440 ipfiremake Mail-Tools
441 ipfiremake MIME-Tools
442 ipfiremake Net-Server
443 ipfiremake Convert-TNEF
444 ipfiremake Convert-UUlib
445 ipfiremake Archive-Tar
446 ipfiremake Archive-Zip
447 ipfiremake Text-Tabs+Wrap
448 ipfiremake Locale-Country
449 ipfiremake GeoIP
450 ipfiremake fwhits
451 ipfiremake noip_updater
452 ipfiremake ntp
453 ipfiremake oinkmaster
454 ipfiremake openssh
455 ipfiremake openswan
456 ipfiremake pptpclient
457 ipfiremake rrdtool
458 ipfiremake setserial
459 ipfiremake setup
460 ipfiremake snort
461 ipfiremake squid
462 ipfiremake squid-graph
463 ipfiremake squidguard
464 ipfiremake tcpdump
465 ipfiremake traceroute
466 ipfiremake vlan
467 ipfiremake wireless
468 ipfiremake libsafe
469 ipfiremake 3c5x9setup
470 ipfiremake pakfire
471 ipfiremake startscripts
472 ipfiremake java
473 ipfiremake bootsplash
474 ipfiremake spandsp
475 ipfiremake lzo
476 ipfiremake openvpn
477 ipfiremake pkg-config
478 ipfiremake glib
479 ipfiremake pammysql
480 ipfiremake saslauthd PASS=2
481 ipfiremake xinetd
482 ipfiremake ghostscript
483 ipfiremake cups
484 ipfiremake samba
485 ipfiremake sudo
486 ipfiremake mc
487 ipfiremake wget
488 ipfiremake wput
489 ipfiremake bridge-utils
490 ipfiremake screen
491 ipfiremake hddtemp
492 ipfiremake smartmontools
493 ipfiremake htop
494 ipfiremake lynx
495 ipfiremake postfix
496 ipfiremake procmail
497 ipfiremake fetchmail
498 ipfiremake cyrusimap
499 ipfiremake webcyradm
500 ipfiremake mailx
501 ipfiremake clamav
502 ipfiremake razor
503 ipfiremake spamassassin
504 # ipfiremake amavisd
505 ipfiremake stund
506 ipfiremake zaptel
507 ipfiremake libpri
508 ipfiremake bristuff
509 ipfiremake asterisk
510 ipfiremake mpg123
511 ipfiremake libmad
512 ipfiremake libogg
513 ipfiremake libvorbis
514 ipfiremake lame
515 ipfiremake xvid
516 ipfiremake mpeg2dec
517 ipfiremake ffmpeg
518 ipfiremake sox
519 ipfiremake gnump3d
520 ipfiremake videolan
521 ipfiremake applejuice
522 ipfiremake ocaml
523 ipfiremake mldonkey
524 ipfiremake ntop
525 ipfiremake rsync
526 ipfiremake tcpwrapper
527 ipfiremake portmap
528 ipfiremake nfs
529 ipfiremake nmap
530 ipfiremake mbmon
531 ipfiremake iftop
532 ipfiremake ncftp
533 ipfiremake cftp
534 ipfiremake etherwake
535 ipfiremake ethereal
536 ipfiremake tftp-hpa
537 ipfiremake iptraf
538 ipfiremake nagios
539 ipfiremake yasuc
540 }
541
542 buildinstaller() {
543 # Run installer scripts one by one
544 LOGFILE="$BASEDIR/log/_build.installer.log"
545 export LOGFILE
546 ipfiremake syslinux
547 ipfiremake as86
548 ipfiremake mbr
549 ipfiremake uClibc
550 installmake busybox
551 installmake sysvinit
552 installmake e2fsprogs
553 installmake misc-progs
554 installmake slang
555 installmake util-linux
556 installmake newt
557 installmake pciutils
558 installmake pcmcia-cs
559 installmake kbd
560 installmake installer
561 installmake scsi.img
562 installmake driver.img
563 installmake initrd
564 installmake boot.img
565 }
566
567 buildpackages() {
568 LOGFILE="$BASEDIR/log/_build.packages.log"
569 export LOGFILE
570 echo "... see detailed log in _build.*.log files" >> $LOGFILE
571 echo -ne "`date -u '+%b %e %T'`: Stage5 packages build \n" | tee -a $LOGFILE
572 # Strip files
573 echo "`date -u '+%b %e %T'`: Stripping files" | tee -a $LOGFILE
574 find $LFS/lib $LFS/usr/lib $LFS/usr/share/rrdtool-* $LFS/install ! -type l \( -name '*.so' -o -name '*.so[\.0-9]*' \) \
575 ! -name 'libc.so' ! -name 'libpthread.so' ! -name 'libcrypto.so.0.9.7.sha1' \
576 -exec $LFS/tools/bin/strip --strip-all {} \; >> $LOGFILE 2>&1
577 # add -ls before -exec if you want to verify what files are stripped
578
579 find $LFS/{,s}bin $LFS/usr/{,s}bin $LFS/usr/local/{,s}bin ! -type l \
580 -exec file {} \; | grep " ELF " | cut -f1 -d ':' | xargs $LFS/tools/bin/strip --strip-all >> $LOGFILE 2>&1
581 # there add -v to strip to verify
582
583 if [ 'i386' = $MACHINE ]; then
584 # Create fcdsl packages
585 echo "`date -u '+%b %e %T'`: Building fcdsl tgz" | tee -a $LOGFILE
586 cp $LFS/install/images/fcdsl/license.txt $LFS >> $LOGFILE 2>&1
587 touch $LFS/var/run/{need-depmod-$KVER,need-depmod-$KVER-smp}
588 cd $LFS && tar cvfz $LFS/install/images/$SNAME-fcdsl-$VERSION.$MACHINE.tgz \
589 lib/modules/$KVER/misc/fcdsl*.o.gz \
590 lib/modules/$KVER-smp/misc/fcdsl*.o.gz \
591 usr/lib/isdn/{fds?base.bin,fd?ubase.frm} \
592 etc/fcdsl/fcdsl*.conf \
593 etc/drdsl/{drdsl,drdsl.ini} \
594 license.txt \
595 var/run/{need-depmod-$KVER,need-depmod-$KVER-smp} >> $LOGFILE 2>&1
596 rm -f $LFS/license.txt >> $LOGFILE 2>&1
597 cd $BASEDIR
598 fi
599
600 # Generating list of packages used
601 echo "`date -u '+%b %e %T'`: Generating packages list from logs" | tee -a $LOGFILE
602 rm -f $BASEDIR/doc/packages-list
603 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
604 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
605 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
606 fi
607 done
608 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
609 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|ipfire$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$' \
610 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
611 rm -f $BASEDIR/doc/packages-list
612 # packages-list.txt is ready to be displayed for wiki page
613
614 # Create ISO for CDROM
615 ipfiremake cdrom
616 rm -f $LFS/install/images/*usb*
617 cp $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
618
619 ipfirepackages
620
621 # Cleanup
622 stdumount
623 rm -rf $BASEDIR/build/tmp/*
624
625 # Generating total list of files
626 echo "`date -u '+%b %e %T'`: Generating files list from logs" | tee -a $LOGFILE
627 rm -f $BASEDIR/log/FILES
628 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
629 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
630 echo "##" >>$BASEDIR/log/FILES
631 echo "## `basename $i`" >>$BASEDIR/log/FILES
632 echo "##" >>$BASEDIR/log/FILES
633 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
634 fi
635 done
636 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
637 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
638
639 cd $PWD
640
641 }
642
643 ipfirepackages() {
644 if [ -d "$BASEDIR/packages" ]; then
645 for i in `ls $BASEDIR/packages`; do
646 touch $BASEDIR/build/install/packages/$i.empty
647 done
648 fi
649 # ipfiredist amavisd
650 ipfiredist applejuice
651 ipfiredist asterisk
652 ipfiredist clamav
653 ipfiredist cups
654 ipfiredist cyrusimap
655 ipfiredist fetchmail
656 ipfiredist ffmpeg
657 ipfiredist gnump3d
658 ipfiredist iptraf
659 ipfiredist java
660 ipfiredist lame
661 ipfiredist libmad
662 ipfiredist libogg
663 ipfiredist libvorbis
664 ipfiredist mailx
665 ipfiredist mldonkey
666 ipfiredist mpeg2dec
667 ipfiredist nagios
668 ipfiredist nfs
669 ipfiredist nmap
670 ipfiredist ntop
671 ipfiredist portmap
672 ipfiredist postfix
673 ipfiredist procmail
674 ipfiredist samba
675 ipfiredist sox
676 ipfiredist spamassassin
677 ipfiredist subversion
678 ipfiredist videolan
679 ipfiredist webcyradm
680 ipfiredist xvid
681 ipfiredist yasuc
682 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
683 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
684 rm -rf $BASEDIR/build/install/packages/*
685 }
686
687 # See what we're supposed to do
688 case "$1" in
689 build)
690 clear
691 BUILDMACHINE=`uname -m`
692 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
693 #only restore on a clean disk
694 if [ ! -f log/cleanup-toolchain-2-tools ]; then
695 if [ ! -n "$PACKAGE" ]; then
696 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
697 prepareenv
698 buildtoolchain
699 else
700 PACKAGENAME=${PACKAGE%.tar.gz}
701 beautify build_stage "Packaged toolchain compilation"
702 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
703 tar zxf $PACKAGE
704 prepareenv
705 else
706 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
707 fi
708 fi
709 else
710 echo -n "Using installed toolchain" | tee -a $LOGFILE
711 beautify message SKIP
712 prepareenv
713 fi
714
715 beautify build_stage "Building base"
716 buildbase
717
718 beautify build_stage "Building IPFire"
719 buildipfire
720
721 # Setzen des IPFire Builds
722 if [ "$FIREBUILD" ]; then
723 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
724 else
725 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
726 fi
727
728 beautify build_stage "Building installer"
729 buildinstaller
730
731 beautify build_stage "Building packages"
732 buildpackages
733 ;;
734 shell)
735 # enter a shell inside LFS chroot
736 # may be used to changed kernel settings
737 prepareenv
738 entershell
739 ;;
740 changelog)
741 echo -n "Loading new Changelog from SVN: "
742 svn log http://svn.ipfire.eu/svn/ipfire > doc/ChangeLog
743 echo "Finished!"
744 ;;
745 clean)
746 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
747 $LOSETUP -d $i 2>/dev/null
748 done
749 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
750 umount $i
751 done
752 stdumount
753 for i in `seq 0 7`; do
754 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
755 umount /dev/loop${i} 2>/dev/null;
756 losetup -d /dev/loop${i} 2>/dev/null;
757 fi;
758 done
759 rm -rf $BASEDIR/build
760 rm -rf $BASEDIR/cdrom
761 rm -rf $BASEDIR/packages
762 rm -rf $BASEDIR/log
763 if [ -h /tools ]; then
764 rm -f /tools
765 fi
766 ;;
767 newpak)
768 # create structure for a new package
769 echo -e "Name of the new package: $2"
770 if [ ! -f "lfs/$2" ]; then
771 echo "`date -u '+%b %e %T'`: Creating directory src/paks/$2"
772 mkdir -p src/paks/$2
773 cd src/paks/$2
774 echo "`date -u '+%b %e %T'`: Creating files"
775 cp $BASEDIR/lfs/postfix $BASEDIR/lfs/$2
776
777 touch ROOTFILES
778 touch {,un}install.sh
779 ## install.sh
780 echo '#!/bin/bash' > install.sh
781 echo '#' >> install.sh
782 echo '#################################################################' >> install.sh
783 echo '# #' >> install.sh
784 echo '# This file belongs to IPFire Firewall - GPLv2 - www.ipfire.org #' >> install.sh
785 echo '# #' >> install.sh
786 echo '#################################################################' >> install.sh
787 echo '#' >> install.sh
788 echo '# Extract the files' >> install.sh
789 echo 'tar xfz files.tgz -C /' >> install.sh
790 echo 'cp -f ROOTFILES /opt/pakfire/installed/ROOTFILES.$2' >> install.sh
791 ## uninstall.sh
792 echo '#!/bin/bash' > uninstall.sh
793 echo '#################################################################' >> uninstall.sh
794 echo '# #' >> uninstall.sh
795 echo '# This file belongs to IPFire Firewall - GPLv2 - www.ipfire.org #' >> uninstall.sh
796 echo '# #' >> uninstall.sh
797 echo '#################################################################' >> uninstall.sh
798 echo '#' >> uninstall.sh
799 echo '# Delete the files' >> uninstall.sh
800 echo '## Befehl fehlt noch' >> uninstall.sh
801 echo 'rm -f /opt/pakfire/installed/ROOTFILES.$2' >> uninstall.sh
802 echo "`date -u '+%b %e %T'`: Adding files to SVN"
803 cd - && svn add lfs/$2 && svn add src/paks/$2
804
805 echo -n "Do you want to remove the folders? [y/n]"
806 read REM
807 if [ "$REM" == "y" ]; then
808 echo "Removing the folders..."
809 svn del src/paks/$2 --force
810 else
811 echo "Folders are kept."
812 fi
813 else
814 echo "$2 already exists"
815 fi
816 exit 0
817 ;;
818 prefetch)
819 if [ ! -d $BASEDIR/cache ]; then
820 mkdir $BASEDIR/cache
821 fi
822 mkdir -p $BASEDIR/log
823 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
824 FINISHED=0
825 cd $BASEDIR/lfs
826 for c in `seq $MAX_RETRIES`; do
827 if (( FINISHED==1 )); then
828 break
829 fi
830 FINISHED=1
831 cd $BASEDIR/lfs
832 for i in *; do
833 if [ -f "$i" -a "$i" != "Config" ]; then
834 echo -ne "Loading $i"
835 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
836 if [ $? -ne 0 ]; then
837 beautify message FAIL
838 FINISHED=0
839 else
840 if [ $c -eq 1 ]; then
841 beautify message DONE
842 fi
843 fi
844 fi
845 done
846 done
847 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
848 ERROR=0
849 for i in *; do
850 if [ -f "$i" -a "$i" != "Config" ]; then
851 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
852 if [ $? -ne 0 ]; then
853 echo -ne "MD5 difference in lfs/$i"
854 beautify message FAIL
855 ERROR=1
856 fi
857 fi
858 done
859 if [ $ERROR -eq 0 ]; then
860 echo -ne "${BOLD}all files md5sum match${NORMAL}"
861 beautify message DONE
862 else
863 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
864 beautify message FAIL
865 fi
866 cd - >/dev/null 2>&1
867 ;;
868 toolchain)
869 clear
870 prepareenv
871 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
872 buildtoolchain
873 BUILDMACHINE=`uname -m`
874 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
875 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
876 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
877 build/{bin,etc,usr/bin,usr/local} \
878 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
879 log >> $LOGFILE
880 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
881 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
882 stdumount
883 ;;
884 gettoolchain)
885 BUILDMACHINE=`uname -m`
886 # arbitrary name to be updated in case of new toolchain package upload
887 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
888 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
889 URL_IPFIRE=`grep URL_IPFIRE lfs/Config | awk '{ print $3 }'`
890 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
891 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
892 cd $BASEDIR/cache/toolchains
893 wget $URL_IPFIRE/toolchains/$PACKAGE.tar.gz $URL_IPFIRE/toolchains/$PACKAGE.md5 >& /dev/null
894 if [ $? -ne 0 ]; then
895 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
896 else
897 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
898 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
899 else
900 exiterror "$PACKAGE.md5 did not match, check downloaded package"
901 fi
902 fi
903 else
904 echo "Toolchain is already downloaded. Exiting..."
905 fi
906 ;;
907 othersrc)
908 prepareenv
909 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
910 chroot $LFS /tools/bin/env -i HOME=/root \
911 TERM=$TERM PS1='\u:\w\$ ' \
912 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
913 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
914 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
915 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
916 if [ $? -eq "0" ]; then
917 beautify message DONE
918 else
919 beautify message FAIL
920 fi
921 stdumount
922 ;;
923 svn)
924 case "$2" in
925 update|up)
926 # clear
927 echo -ne "Loading the latest source files...\n"
928 if [ $3 ]; then
929 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
930 else
931 svn update | tee -a $PWD/log/_build.svn.update.log
932 fi
933 if [ $? -eq "0" ]; then
934 beautify message DONE
935 else
936 beautify message FAIL
937 exit 1
938 fi
939 echo -ne "Writing the svn-info to a file"
940 svn info > $PWD/svn_status
941 if [ $? -eq "0" ]; then
942 beautify message DONE
943 else
944 beautify message FAIL
945 exit 1
946 fi
947 chmod 755 $0
948 exit 0
949 ;;
950 commit|ci)
951 clear
952 if [ -f /usr/bin/mcedit ]; then
953 export EDITOR=/usr/bin/mcedit
954 else
955 if [ -f /usr/bin/nano ]; then
956 export EDITOR=/usr/bin/nano
957 fi
958 fi
959 echo -ne "Selecting editor $EDITOR..."
960 beautify message DONE
961 if [ -e /sbin/yast ]; then
962 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
963 $0 changelog
964 fi
965 fi
966 svn commit
967 $0 svn up
968 $0 uploadsrc
969 ;;
970 dist)
971 if [ $3 ]; then
972 SVN_REVISION=$3
973 fi
974 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
975 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
976 exit 0
977 fi
978 echo -en "REV $SVN_REVISION: Downloading..."
979 svn export http://svn.ipfire.eu/svn/ipfire/trunk ipfire-source/ --force > /dev/null
980 svn log http://svn.ipfire.eu/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
981 #svn info http://svn.ipfire.eu/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
982 evaluate 1
983
984 echo -en "REV $SVN_REVISION: Compressing files..."
985 if [ -e ipfire-source/trunk/make.sh ]; then
986 chmod 755 ipfire-source/trunk/make.sh
987 fi
988 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
989 evaluate 1
990 echo -en "REV $SVN_REVISION: Cleaning up..."
991 rm ipfire-source/ -r
992 evaluate 1
993 ;;
994 diff|di)
995 echo -ne "Make a local diff to last svn revision"
996 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
997 evaluate 1
998 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
999 ;;
1000 esac
1001 ;;
1002 uploadsrc)
1003 PWD=`pwd`
1004 cd $BASEDIR/cache/
1005 echo -e "Uploading cache to ftp server:"
1006 ncftpls -u $IPFIRE_FTP_USER_INT -p $IPFIRE_FTP_PASS_INT ftp://$IPFIRE_FTP_URL_INT$IPFIRE_FTP_PATH_INT/ > /var/tmp/ftplist
1007 for i in *; do
1008 if [ "$i" == "toolchains" ]; then continue; fi
1009 grep -q $i /var/tmp/ftplist
1010 if [ "$?" -ne "0" ]; then
1011 echo -ne "$i"
1012 ncftpput -bb -u $IPFIRE_FTP_USER_INT -p $IPFIRE_FTP_PASS_INT $IPFIRE_FTP_URL_INT $IPFIRE_FTP_PATH_INT/ $i > /dev/null 2>&1
1013 if [ "$?" -eq "0" ]; then
1014 beautify message DONE
1015 else
1016 beautify message FAIL
1017 fi
1018 fi
1019 done
1020 rm -f /var/tmp/ftplist
1021 UL_TIME_START=`date +'%s'`
1022 ncftpbatch -d > /dev/null 2>&1
1023 while ps acx | grep -q ncftpbatch
1024 do
1025 UL_TIME=$(expr `date +'%s'` - $UL_TIME_START)
1026 echo -ne "\r ${UL_TIME}s : Upload is running..."
1027 sleep 1
1028 done
1029 beautify message DONE
1030 cd $PWD
1031 exit 0
1032 ;;
1033 upload)
1034 case "$2" in
1035 iso)
1036 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
1037 cat <<EOF > .ftp-commands
1038 mkdir $IPFIRE_FTP_PATH_EXT
1039 ls -lah
1040 quit
1041 EOF
1042 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
1043 rm -f .ftp-commands
1044 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
1045 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-install-$VERSION.i386.iso
1046 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-install-$VERSION.i386.iso.md5
1047 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-source-r$SVN_REVISION.tar.gz
1048 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ svn_status
1049 if [ "$?" -eq "0" ]; then
1050 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
1051 else
1052 echo -e "There was an error while uploading the iso to the ftp server."
1053 exit 1
1054 fi
1055 if [ "$3" = "--with-sources-cd" ]; then
1056 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-sources-cd-$VERSION.$MACHINE.iso
1057 fi
1058 ;;
1059 paks)
1060 cat <<EOF > .ftp-commands
1061 mkdir $IPFIRE_FTP_PATH_PAK
1062 ls -lah
1063 quit
1064 EOF
1065 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
1066 rm -f .ftp-commands
1067 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
1068 if [ "$?" -eq "0" ]; then
1069 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
1070 else
1071 echo -e "There was an error while uploading the packages to the ftp server."
1072 exit 1
1073 fi
1074 ;;
1075 esac
1076 ;;
1077 batch)
1078 if [ "$2" -eq "--background" ]; then
1079 batch_script
1080 exit $?
1081 fi
1082 if [ `screen -ls | grep -q ipfire` ]; then
1083 echo "Build is already running, sorry!"
1084 exit 1
1085 else
1086 if [ "$2" = "--rebuild" ]; then
1087 export IPFIRE_REBUILD=1
1088 echo "REBUILD!"
1089 else
1090 export IPFIRE_REBUILD=0
1091 fi
1092 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1093 screen -dmS ipfire $0 batch --background
1094 evaluate 1
1095 exit 0
1096 fi
1097 ;;
1098 watch)
1099 watch_screen
1100 ;;
1101 "")
1102 clear
1103 svn info
1104 select name in "Exit" "IPFIRE: Prefetch" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1105 do
1106 case $name in
1107 "IPFIRE: Prefetch")
1108 $0 prefetch
1109 ;;
1110 "IPFIRE: Build (silent)")
1111 $0 build-silent
1112 ;;
1113 "IPFIRE: Watch Build")
1114 $0 watch
1115 ;;
1116 "IPFIRE: Batch")
1117 $0 batch
1118 ;;
1119 "IPFIRE: Clean")
1120 $0 clean
1121 ;;
1122 "SVN: Update")
1123 $0 svn update
1124 ;;
1125 "Help")
1126 echo "Usage: $0 {build|changelog|clean|gettoolchain|newpak|prefetch|shell|sync|toolchain}"
1127 cat doc/make.sh-usage
1128 ;;
1129 "LOG: Tail")
1130 tail -f log/_*
1131 ;;
1132 "Exit")
1133 break
1134 ;;
1135 esac
1136 done
1137 ;;
1138 *)
1139 echo "Usage: $0 {build|changelog|clean|gettoolchain|newpak|prefetch|shell|sync|toolchain}"
1140 cat doc/make.sh-usage
1141 ;;
1142 esac